import socket
import select
import signal
import datetime
import time
#Si quieres activar el programa de SocketReaccion, debes quitarle el #
#from SocketReaccion import socketreaccion

horaRaw = time.time()
horaF = time.localtime(horaRaw)
fecha= datetime.date.today()
hoy= fecha.strftime("%d,%m,%Y")
horaFinal = str(horaF.tm_hour)+":"+str(horaF.tm_min)+":"+str(horaF.tm_sec) 
filename = "Log "+horaFinal+" "+hoy+".xml"
datoanomalo = False

# Funcion que usamos para tratar, cuando damos a control + C, y se interrumpe el programa
def handler( signum, frame):
	print 'error'	
	f = open(filename, 'a')
	f.write("</xml>")
	f.close()
	ith = Lista.__iter__()
	try:
        	m = ith.next()
        except StopIteration:
		print ""
	m.close()
# Crea y prepara el xml
def preparacionWrite():
	f = open(filename, 'w')
	f.write("<xml>"+'\n')
	f.close()

def RecogiendoInfo():
	# esta funcion sirve para que cuando detecta el cierre del programa forzado efectue la funcion handler, que sera nuestro tratamiento de error
	signal.signal(signal.SIGINT, handler)
	print 'Iniciando el programa'
	server = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	# creamos el socket servidor
	server.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
	# cambiamos las opciones para que el socket sea liberado cada vez k se usa
	server.bind(('0.0.0.0',9999))
	# le damos al socket server la direccion de escucha (escucha en todas las ips del ordenador)
	server.listen(5)
	print 'Creamos y damos direccion al objeto servidor'
	# 5 escuchas
	# Creamos un conjunto
	Lista = set()
	print 'Introducimos el objeto servidor'
	Lista.add(server)
	preparacionWrite()
	print 'Entramos en el bucle de select'
	while 1:	
		recuento = Lista.__len__()-1
		print " Cliente conectados:" , recuento
		horaRaw = time.time()
		horaF = time.localtime(horaRaw)
		rlist, wlist, mlist = select.select(Lista,[],[])
		itl = rlist.__iter__()
		# creamos iterador
		# efectuamos funcion select (una especie de trigger, si llega un evento pasa hacia delante 
		# iteramos la lista	
		try: 
			i = itl.next()
		except StopIteration:
			break
		if(i==server):
			# se comprueba si es un servidor, y efectuamos el accept
			# hay un objeto 
			cliente , ip = i.accept()			
			Lista.add(cliente)
			cliente.send("GET /xml-arduino/protocol HTTP/1.1\nHost: localhost\n")
			# Aceptamos la conexion y la guardamos
		else:
			print "Estado recibiendo"
			texto = i.recv(1024)
			if(texto == "0"):
				i.close()
				continue
			#Separar mensajes y los datos para depues tratarlos	
			textpar1 = texto.partition("Content-Length: 49")
			confirmationmsg3 = textpar1[1]
			recievedata = textpar1[2]
			texttemp = textpar1[0]
			textpar2 = texttemp.partition("Content-Type: text/plain;charset=UTF-8")
			confirmationmsg = textpar2[0]
			confirmationmsg2 = textpar2[1]
			print confirmationmsg
			print confirmationmsg2
			print confirmationmsg3
			textpar3 = recievedata.partition("<entry>")
			texttemp3 = textpar3[2]
			textpar4 = texttemp3.partition("</xml>")
			textfinal = textpar4[0]
			textpar5 = textfinal.partition("<temperature>")
			texttemp5 = textpar5[2]
			textalert = texttemp5.partition("</temperature>")[0]
			#Tratamos los datos recibidos, y comprobamos si la temperatura ha aumentado mas de 55 grados, si es asi salta el programa de reaccion 
			# Si se quiere activar el programa SocketReaccion debes quitar los #, de las 5 siguientes lineas
			
			#if(int(textalert) >=55):
				#print "Dato Anomalo"
				#if(datoanomalo == True):	
				#	socketreaccion().ReaccionFuego()
				#	datoanomalo = False
				#else:
				#	datoanomalo = True
			#else:
			#	print "Nada Anormal"		
			f = open (filename, 'a')
			#Escribimos en el archivo prueba1.txt
			horaRaw = time.time()
			horaF = time.localtime(horaRaw)
			fecha= datetime.date.today()
			hoy= fecha.strftime("%d/%m/%Y")
			horaFinal = str(horaF.tm_hour)+":"+str(horaF.tm_min)+":"+str(horaF.tm_sec)
			f.write("<entry>"+'\n')
			f.write("<clock>"+horaFinal+"</clock>"+'\n')
			f.write("<date>"+hoy+"</date>"+'\n')
			f.write(textfinal)
			f.close()
			Lista.remove(i)
			i.close()


RecogiendoInfo()

